;---------------------------------
; modu asemblera do pckeyb.c
; odczyt/zapis klawiatury
;---------------------------------
; kompilator:RA-51 Raisonance
;---------------------------------

keyboard_asm SEGMENT CODE

;zewntrzne jednobajtowe komrki pamici danych
EXTRN DATA (temp)								;komrka "bufora" danych
EXTRN DATA (temp1)							; - / / -

;zewntrzna procedura zaimplementowana w jzyku C
EXTRN CODE (_Delay)

;funkcje obsugi klawiatury
PUBLIC _TX_byte								;zapis bajtu do klawiatury
PUBLIC RX_byte									;odbir bajtu

;linie podczenia klawiatury
KbdClock		BIT		P0.0					;zegar
KbdData		BIT		P0.1					;dane


;--------------------------------
; program gwny
;--------------------------------
;
RSEG keyboard_asm

;oczekiwanie na zmian stanu linii zegara
Low2High:	JNB	KbdClock,$
				JB		KbdClock,$
				RET


;wysanie bajtu do klawiatury,bajt przekazywany przez jzyk c w R7
_TX_byte:	MOV	B,#8						;liczba bitw do wysania
				MOV	temp,R7					;zapamitanie parametru wywoania
				CLR	KbdClock
				MOV	R7,#2						;opnienie 2 ms
				MOV	R6,#0
				CALL	_Delay
				CLR	KbdData					;Request To Send
				SETB	KbdClock
				ACALL	Low2High					;oczekiwanie na potw.bit startu

				MOV	A,temp					;odtworzenie zawartoci A (tzn.znak do wysyki)
TX_Loop:
				RRC	A							;wysanie 8 bitw
				MOV	KbdData,C
				ACALL	Low2High
				DJNZ	B,TX_Loop
				
				MOV	A,temp					;wysanie bitu parzystoci
				MOV	C,PSW.0					;(flaga PARITY)
				CPL	C
				MOV	KbdData,C
				ACALL	Low2High

				SETB	KbdData					;Stop Bit
				ACALL	Low2High
				ACALL	Low2High					;Keyboard Ack.
				CLR	KbdClock
				RET


;odczyt bajtu z klawiatury,bajt zwracany w R7
RX_byte:		SETB	KbdClock
				JB		KbdClock,$
				JNB	KbdData,RX_byte_Cont
				SJMP	RX_byte_Error
RX_byte_Cont:
				MOV	B,#8						;licznik odebranych bitw
RX_byte_Loop:
				ACALL	Low2High					;odbir 8 bitw
				MOV	C,KbdData
				RRC	A
				DJNZ	B,RX_byte_Loop
				MOV	temp,A					;zapamitanie odebranego znaku

				ACALL	Low2High
				MOV	C,KbdData				;Parity Bit
				RLC	A

				ACALL	Low2High
				MOV	C,KbdData				;Stop Bit
				RLC	A
				MOV	temp1,A					;zapamitanie bitu stopu i parzystoci
				
				ANL	A,#1						;sprawdzenie bitu stopu
				JZ		RX_byte_Error
				
				MOV	A,temp					;sprawdzenie parzystoci (w temp odczytana liczba)
				MOV	C,PSW.0					;czy odczytana liczba ma parzyst liczb 1?
				RLC	A
				ANL	A,#1						;maskowanie niepotrzebnych bitw
				XCH	A,temp1					;zamiana miejscami odczytanego i wyliczonego bitu parz.
				ANL	A,#2						;maskowanie bitw
				RR		A							;dopasowanie pozycji bitw
				XRL	A,temp1					;porwnanie bitw parzystoci
				JZ		RX_byte_Error
				SJMP	RX_byte_End
RX_byte_Error:
				MOV	R7,#1
				MOV	R6,#0
				ACALL	_Delay
				MOV	temp,#0
RX_byte_End:
				MOV	R7,temp
				CLR	KbdClock
				RET

END
